	.486
	locals @@
;------------------------- program a data ------------------------
TIME	equ 800
code	segment	use16
	assume cs:code,ds:code
	org 100h
hmmm:	jmp START
	db 0

never	db 'Tohle se nikdy nemohlo prihodit.',0dh,0ah,'$'
pod386	db 'Tento program vyzaduje alespon 110000010 !',13,10,36
ok	db 'Chrocht!',13,10,36
helptxt	db 'Pouziti: testpci prikaz',13,10,'prikazy:',13,10
	db ' mread......cteni jednoho bytu z pameti',13,10
        db ' mwrite.....zapis jednoho bytu do pameti',13,10
        db ' ioread.....cteni 8-bitoveho portu',13,10
        db ' iowrite....zapis 8-bitoveho portu',13,10
        db ' bytemerge..spojovani nekolika 8-bitovych zapisu',13,10
        db ' cfgread....cteni konfiguracniho registru',13,10
        db ' longwrite..zapis nekolika po sobe nasledujicich dwordu',13,10
        db ' iack.......potvrzovani preruseni, vyslani vektoru',13,10
        db ' special....vyvolani specialniho cyklu',13,10,36
        db ' mread......cteni jednoho bytu z pameti',13,10
        db ' mread......cteni jednoho bytu z pameti',13,10

;------------------ procedury jednotlivych prikazu ----------------

mread	proc near
	mov bx,TIME
        mov dx,0b800h
	mov es,dx
	cli
@@lp:	mov al,es:[0]
	loop @@lp
	dec bx
	jnz short @@lp
	sti
	ret
mread	endp

mwrite	proc near
	mov bx,TIME
        mov dx,0B800h
	mov es,dx
	cli
@@lp:	mov dword ptr es:[0],695A0000h
	mov dword ptr es:[8], 695B1111h
	loop @@lp
	dec bx
	jnz short @@lp
	sti
	ret
mwrite	endp

longwr	proc near
	mov bx,TIME/4
	cli
        mov dx,0B800h
	mov es,dx
	sti
@@lp:	mov dword ptr es:[0],11111111h
	mov dword ptr es:[4],22222222h
	mov dword ptr es:[8],33333333h
	mov dword ptr es:[12],44444444h
	mov dword ptr es:[16],55555555h
	loop @@lp
	dec bx
	jnz short @@lp
	ret
longwr	endp

bmerge	proc near
	mov bx,TIME
	mov dx,0b800h
	mov es,dx
	cli
@@lp:	mov byte ptr es:[0],5ah
	mov byte ptr es:[1],41h
	mov byte ptr es:[2],0ah
	mov byte ptr es:[3],50h
	loop @@lp
	dec bx
	jnz short @@lp
	sti
	ret
bmerge	endp

cfgread	proc near
	mov bx,TIME
	mov dx,0cf8h
	mov es,dx
	cli
@@lp:   mov eax, 48h
        shl eax,11
        or eax,80000001h
	out dx,eax
	add dl,4
	in eax,dx
	sub dl,4
        loop @@lp
	dec bx
	jnz short @@lp
	sti
	ret
cfgread	endp

special	proc near
        mov bx,TIME
        mov dx,0cf8h
        mov es,dx
        cli
@@lp:   mov eax,8000ff00h
        out dx,eax
        add dl,4
	mov eax,55AA55AAh
        out dx,eax
        sub dl,4
        loop @@lp
        dec bx
        jnz short @@lp
        sti
        ret
special	endp

ioread	proc near
	mov bx,TIME
	mov dx,3c5h
	mov es,dx
	cli
@@lp:	in al,dx
	loop @@lp
	dec bx
	jnz short @@lp
	sti
	ret
ioread	endp

iowrite	proc near
	mov bx,TIME
	mov es,dx
	cli
	mov dx,3c5h
	mov al,0
@@lp:	out dx,al
	loop @@lp
	dec bx
	jnz short @@lp
	sti
	ret
iowrite	endp

align 4
cyklovac dd 0
intrut:	push ax
	mov al,20h
	out 20h,al
	out 0a0h,al
	inc cs:cyklovac
	pop ax
	iret

intack	proc near
	in al,21h
	mov ah,al
	in al,0a1h
	push ax
	mov al,0feh
	out 21h,al
	inc al
	out 0a1h,al
	mov ax,3508h
	int 21h
	push es
	push bx
	mov cyklovac,0
	mov dx,offset intrut
	mov ax,2508h
	int 21h
@@lp:	mov eax,cyklovac
	cmp eax,100
	jb short @@lp
	pop dx
	pop ds
	mov ax,2508h
	int 21h
	push cs
	pop ds
	pop ax
	out 0a1h,al
	mov al,ah
	out 21h,al
	ret
intack	endp


help	proc near
	mov ah,9
	mov dx,offset helptxt
	int 21h
	ret
help	endp


;-------------------------------------------------------------------
asc_num	proc near			; prevede cislo v ASCII na es:di do eax
	xor eax,eax			; out:CF..zadne cislo tam nebylo
	dec di
@@nosp:	inc di
	cmp byte ptr es:[di],' '	; nejdriv vynechame pripadne mezery
	jz short @@nosp
an_nosp:cmp byte ptr es:[di],'0'	; kdyz to cislo nezacina cislem, vratime C
	jb short @@nonum
	cmp byte ptr es:[di],'9'
	ja short @@nonum
@@cntn:	cmp byte ptr es:[di],'0'	; je tam cislo ?
	jb short @@eon
	cmp byte ptr es:[di],'9'
	ja short @@eon
	shl eax,1
	mov edx,eax
	shl eax,2
	add eax,edx			; vynasobime 10x
	xor edx,edx
	mov dl,es:[di]
	sub dl,'0'
	add eax,edx			; a pricteme
	inc di
	jmp short @@cntn
@@eon:	clc
	ret
@@nonum:stc
	ret
asc_num	endp

mezeru:	dec di				; najde mezeru+- v retezci v di
mez1:	inc di
	cmp di,100h
	jz short strange
	cmp byte ptr es:[di],' '
	jz short rret
	cmp byte ptr es:[di],'/'
	jz short rret
	cmp byte ptr es:[di],0dh
	jnz short mez1
rret:	ret

znak:	dec di				; najde ne-mezeru
zn1:	inc di
	cmp di,100h
	jz short strange
	cmp byte ptr es:[di],0dh
	jz short rret
	cmp byte ptr es:[di],' '
	jz short zn1
	ret

strange:mov dx,offset never
	jmp KONEC

rozskok dw offset mread
	db 'MREAD$        '
	dw offset mwrite
	db 'MWRITE$       '
	dw offset ioread
	db 'IOREAD$       '
	dw offset iowrite
	db 'IOWRITE$      '
	dw offset cfgread
	db 'CFGREAD$      '
	dw offset bmerge
	db 'BYTEMERGE$    '
	dw offset intack
	db 'IACK$         '
	dw offset special
	db 'SPECIAL$      '
	dw offset longwr
	db 'LONGWRITE$    '
	dw offset help			; kdyz nic nesouhlasi, zobrazime help
        db '$             '
START:	push cs
	pop ds

	mov ax,0ffffh			; nejdriv otestujem procesor (chci 386)
	mov cl,20h
	shl ax,cl
	and ax,ax
	mov dx,offset pod386
	jz KONEC			; PCI na 286 ? chm ne
	push es

	mov di,81h			; mrkneme se na radkove parametry
params:	call mezeru
	call znak
	mov dx,offset rozskok
	dec di
	mov cx,di

parlp:	mov si,dx
	add si,2
parlp2:	inc di
	mov al,[si]
	inc si
	cmp al,'$'
	jz short nasel
	cmp al,es:[di]
	jz short parlp2			; zatim se to shoduje
	add al,'a'-'A'
	cmp al,es:[di]
	jz short parlp2
	add dx,16
	mov di,cx
	jmp short parlp

nasel:	mov si,dx
	call [si]

	mov dx,offset ok
KONEC:	push cs
	pop ds
	mov ah,9
	int 21h
k:	mov ax,4c00h
	int 21h

code	ends

end	hmmm

